diff --git a/game/client/src/main/java/net/minecraft/client/option/GameSettings.java b/game/client/src/main/java/net/minecraft/client/option/GameSettings.java
index e8445791d..b21898223 100644
--- a/game/client/src/main/java/net/minecraft/client/option/GameSettings.java
+++ b/game/client/src/main/java/net/minecraft/client/option/GameSettings.java
@@ -9,7 +9,6 @@ import net.minecraft.client.discord.RichPresenceHandlerThread;
 import net.minecraft.client.enums.MusicFrequency;
 import net.minecraft.client.enums.SelectedSoundtrack;
 import net.minecraft.client.gui.TooltipElement;
-import net.minecraft.client.gui.hud.component.HudComponent;
 import net.minecraft.client.gui.hud.component.HudComponents;
 import net.minecraft.client.gui.options.ScreenOptions;
 import net.minecraft.client.input.InputDevice;
@@ -134,7 +133,7 @@ public final class GameSettings {
     public static final @NotNull OptionBoolean VIEW_BOBBING = register(new OptionBoolean("bobView", true));
     public static final @NotNull OptionBoolean TRANSPARENCY_DEPTH_CHECK = register(new OptionBoolean("transparencyDepthCheck", true));
     public static final @NotNull OptionEnum<ParticlesQuality> PARTICLES_QUALITY = register(new OptionEnum<>("particleQuality", ParticlesQuality.class, ParticlesQuality.ALL));
-    public static final @NotNull OptionRange PARTICLES_CAP = register(new OptionRange("particleCap", 50000, 1000, 100000));
+    public static final @NotNull OptionRange PARTICLES_CAP = register(new OptionRange("particleCap", 4000, 500, 15000));
     public static final @NotNull OptionRange PARTICLE_RENDER_DISTANCE = register(new OptionRange("particleRenderDistance", 8, 1, 24)
         .addOnChangeCallback((mc, option) -> {
             if (mc.currentScreen instanceof ScreenOptions) {
@@ -272,11 +271,6 @@ public final class GameSettings {
             }
         })
         .withDisplayStringProvider((mc, i18n, option) -> {
-            for (HudComponent component : HudComponents.INSTANCE.getComponents()) {
-                if (component.getScaleOverride() > 0) {
-                    return i18n.translateKey("options.guiScale.disabled");
-                }
-            }
             if (option.value == 0) {
                 return i18n.translateKey("options.guiScale.auto");
             } else {
@@ -695,6 +689,11 @@ public final class GameSettings {
         HudComponents.DEFAULT_LAYOUT = HudComponents.INSTANCE.toSettingsString();
 
         loadOptions();
+
+        if (!SEEN_HUD_EDITOR_ONBOARDING.value) {
+            HudComponents.INSTANCE.resetToDefault();
+        }
+
         saveOptions();
     }
 
diff --git a/game/client/src/main/java/net/minecraft/client/option/OptionGuiScaleOverride.java b/game/client/src/main/java/net/minecraft/client/option/OptionGuiScaleOverride.java
index d75a8cb59..096b93e0a 100644
--- a/game/client/src/main/java/net/minecraft/client/option/OptionGuiScaleOverride.java
+++ b/game/client/src/main/java/net/minecraft/client/option/OptionGuiScaleOverride.java
@@ -1,24 +1,32 @@
 package net.minecraft.client.option;
 
 import net.minecraft.client.Minecraft;
-import net.minecraft.client.ScaledResolution;
 import net.minecraft.core.lang.I18n;
 import org.jetbrains.annotations.NotNull;
 
 /**
- * Per-instance scale override for HUD components. Behaves much like
- * {@link OptionGuiScale}, but with a "Disabled" entry instead of "Auto"; when
- * {@code value == 0} the component should fall back to the global GUI scale.
+ * Per-instance scale override for HUD components. Has a fixed 1x
+ * to {@value #MAX_SCALE}x range plus a "Disabled" entry; when 0 the
+ * component should fall back to the global GUI scale.
  *
  * <p>Instances of this class are intentionally NOT registered through
  * {@link GameSettings#register}: each HUD Component
  * owns its own instance and serializes it as part of its own settings string.
  */
 public class OptionGuiScaleOverride extends OptionToggleable<Integer> {
+    public static final int MAX_SCALE = 12;
+
     public OptionGuiScaleOverride() {
         super("guiScaleOverride", 0, new Integer[1]);
     }
 
+    public static int clampValue(int value) {
+        if (value <= 0) {
+            return 0;
+        }
+        return Math.min(value, MAX_SCALE);
+    }
+
     @Override
     public void toggle() {
         toggle(1);
@@ -32,28 +40,24 @@ public class OptionGuiScaleOverride extends OptionToggleable<Integer> {
 
     @Override
     public int getValueIndex() {
-        int max = size();
-        if (this.value <= 0 || this.value >= max) {
+        if (this.value <= 0 || this.value > MAX_SCALE) {
             return 0;
         }
-        return max - this.value;
+        return size() - this.value;
     }
 
     @Override
     public void setValueWithIndex(int i) {
-        if (i != 0) {
-            this.value = size() - i;
-        } else {
+        if (i <= 0 || i > MAX_SCALE) {
             this.value = 0;
+        } else {
+            this.value = size() - i;
         }
     }
 
     @Override
     public int size() {
-        Minecraft mc = Minecraft.getMinecraft();
-        int width = mc.gameWindow.getWidthScreenCoords();
-        int height = mc.gameWindow.getHeightScreenCoords();
-        return ScaledResolution.getMaxScale(width, height);
+        return MAX_SCALE + 1;
     }
 
     @Override
@@ -64,7 +68,7 @@ public class OptionGuiScaleOverride extends OptionToggleable<Integer> {
     @Override
     public void fromOptionsString(@NotNull String string) {
         try {
-            this.value = Integer.parseInt(string);
+            this.value = clampValue(Integer.parseInt(string));
         } catch (NumberFormatException e) {
             this.value = 0;
         }
diff --git a/game/client/src/main/java/net/minecraft/client/player/controller/PlayerControllerMP.java b/game/client/src/main/java/net/minecraft/client/player/controller/PlayerControllerMP.java
index 3947bb6d1..4dc8f5ed9 100644
--- a/game/client/src/main/java/net/minecraft/client/player/controller/PlayerControllerMP.java
+++ b/game/client/src/main/java/net/minecraft/client/player/controller/PlayerControllerMP.java
@@ -1,5 +1,7 @@
 package net.minecraft.client.player.controller;
 
+import it.unimi.dsi.fastutil.ints.Int2ObjectArrayMap;
+import it.unimi.dsi.fastutil.ints.Int2ObjectMap;
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.entity.player.PlayerLocalMultiplayer;
 import net.minecraft.client.net.handler.PacketHandlerClient;
@@ -9,6 +11,7 @@ import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.ArtType;
 import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.player.inventory.menu.MenuAbstract;
 import net.minecraft.core.net.packet.*;
 import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.Side;
@@ -116,9 +119,29 @@ public class PlayerControllerMP
 
     @Override
     public @Nullable ItemStack handleInventoryMouseClick(final int windowId, final @NotNull InventoryAction action, final int @Nullable [] args, final @NotNull Player player) {
-        final short actionId = player.containerMenu.backup(player.inventory);
+        final MenuAbstract menu = player.containerMenu;
+
+        final int slotCount = menu.slots.size();
+        final ItemStack[] before = new ItemStack[slotCount];
+        for (int i = 0; i < slotCount; i++) {
+            final ItemStack stack = menu.getSlot(i).getItemStack();
+            before[i] = stack == null ? null : stack.copy();
+        }
+
+        final int stateId = menu.getStateId();
         final @Nullable ItemStack itemStack = super.handleInventoryMouseClick(windowId, action, args, player);
-        this.packetHandler.addToSendQueue(new PacketContainerClick(windowId, action, args, itemStack, actionId));
+
+        final Int2ObjectMap<ItemStack> changedSlots = new Int2ObjectArrayMap<>();
+        for (int i = 0; i < slotCount; i++) {
+            final ItemStack now = menu.getSlot(i).getItemStack();
+            if (!ItemStack.areItemStacksEqual(before[i], now)) {
+                changedSlots.put(i, now == null ? null : now.copy());
+            }
+        }
+        final ItemStack held = player.inventory.getHeldItemStack();
+        final @Nullable ItemStack carriedItem = held == null ? null : held.copy();
+
+        this.packetHandler.addToSendQueue(new PacketContainerClick(windowId, action, args, stateId, changedSlots, carriedItem));
         return itemStack;
     }
 
diff --git a/game/client/src/main/java/net/minecraft/client/render/OpenGLHelper.java b/game/client/src/main/java/net/minecraft/client/render/OpenGLHelper.java
index d27048aa6..a2a33c714 100644
--- a/game/client/src/main/java/net/minecraft/client/render/OpenGLHelper.java
+++ b/game/client/src/main/java/net/minecraft/client/render/OpenGLHelper.java
@@ -103,23 +103,24 @@ public class OpenGLHelper {
     }
 
     public static void checkError(String info) {
-        if (Global.DEBUG_MODE) {
-            int errorCode = GL41.glGetError();
-
-            if (errorCode != GL41.GL_NO_ERROR) {
-                if (Global.BUILD_CHANNEL.isUnstableBuild()) {
-                    String error = errorCode + " (" + getErrorDescription(errorCode) + "): " + info;
-                    throw new RuntimeException("OpenGL Error " + error);
-                }
-
-                if (!errors.contains(info)) {
-                    errors.add(info);
-                    String error = errorCode + " (" + getErrorDescription(errorCode) + "): " + info;
-                    LOGGER.error("########## GL ERROR ##########");
-                    LOGGER.error("OpenGL Error {}", error);
-                }
-            }
-        }
+        // This error checking is not very helpful, the newer logger callback work vastly better
+//        if (Global.DEBUG_MODE) {
+//            int errorCode = GL41.glGetError();
+//
+//            if (errorCode != GL41.GL_NO_ERROR) {
+//                if (Global.BUILD_CHANNEL.isUnstableBuild()) {
+//                    String error = errorCode + " (" + getErrorDescription(errorCode) + "): " + info;
+//                    throw new RuntimeException("OpenGL Error " + error);
+//                }
+//
+//                if (!errors.contains(info)) {
+//                    errors.add(info);
+//                    String error = errorCode + " (" + getErrorDescription(errorCode) + "): " + info;
+//                    LOGGER.error("########## GL ERROR ##########");
+//                    LOGGER.error("OpenGL Error {}", error);
+//                }
+//            }
+//        }
     }
 
     public static String getErrorDescription(int error) {
diff --git a/game/client/src/main/java/net/minecraft/client/render/ParticleEngine.java b/game/client/src/main/java/net/minecraft/client/render/ParticleEngine.java
index 0daeb80e6..28df94f8c 100644
--- a/game/client/src/main/java/net/minecraft/client/render/ParticleEngine.java
+++ b/game/client/src/main/java/net/minecraft/client/render/ParticleEngine.java
@@ -13,7 +13,6 @@ import net.minecraft.client.render.renderer.CompareFunc;
 import net.minecraft.client.render.renderer.GLRenderer;
 import net.minecraft.client.render.renderer.Shaders;
 import net.minecraft.client.render.renderer.State;
-import net.minecraft.client.render.tessellator.TessellatorGeneral;
 import net.minecraft.client.render.tessellator.TessellatorParticle;
 import net.minecraft.client.render.tessellator.TessellatorParticleShader;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
@@ -22,6 +21,7 @@ import net.minecraft.core.block.Blocks;
 import net.minecraft.core.block.material.MaterialGas;
 import net.minecraft.core.block.material.MaterialLiquid;
 import net.minecraft.core.entity.player.Player;
+import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.pos.TilePosc;
@@ -30,9 +30,7 @@ import org.joml.primitives.AABBd;
 import org.joml.primitives.AABBdc;
 import org.lwjgl.opengl.GL41;
 
-import java.util.HashMap;
 import java.util.List;
-import java.util.Map;
 import java.util.Random;
 
 /**
@@ -45,15 +43,11 @@ public final class ParticleEngine {
 
     private final @NotNull TessellatorParticleShader shaderParticleTessellator = new TessellatorParticleShader(4000 * 40);
     private World world;
-    private final List<Particle>[] particles;
+    private final @NotNull List<@NotNull Particle> @NotNull [] particles;
     private final Random rand;
 
-    private final Map<Class<?>, ObjectArrayList<Particle>> particlePools = new HashMap<>();
-    private final AABBd cullingAABB = new AABBd();
-    private int globalTick = 0;
-    private double lastCamX, lastCamY, lastCamZ;
-
     public ParticleEngine(World world) {
+        //noinspection unchecked
         this.particles = new ObjectArrayList[TEXTURE_COUNT];
         this.rand = new Random();
         if (world != null) {
@@ -72,54 +66,20 @@ public final class ParticleEngine {
     public void add(@NotNull Particle particle) {
         int t = particle.getParticleTexture();
 
-        if (this.particles[t].size() >= GameSettings.PARTICLES_CAP.value) {
-            // Find the furthest particle to delete instead of just the oldest
-            int indexToRemove = getIndexToRemove(t);
-
-            // Return the furthest particle to the Object Pool
-            Particle removed = this.particles[t].remove(indexToRemove);
-            ObjectArrayList<Particle> pool = this.particlePools.computeIfAbsent(removed.getClass(), k -> new ObjectArrayList<>());
-            if (pool.size() < GameSettings.PARTICLES_CAP.value) {
-                pool.add(removed);
-            }
+        var s = this.particles[t].size();
+        if (s >= GameSettings.PARTICLES_CAP.value) {
+            this.particles[t].remove(this.rand.nextInt(s));
         }
 
         this.particles[t].add(particle);
         particle.init();
     }
 
-    private int getIndexToRemove(int t) {
-        int indexToRemove = 0;
-        double maxDistSq = -1;
-
-        // Only scan a handful of particles to avoid CPU lag when overflowing
-        int scanLimit = Math.min(50, this.particles[t].size());
-
-        for (int i = 0; i < scanLimit; i++) {
-            Particle check = this.particles[t].get(i);
-            double distSq = (check.x - lastCamX)*(check.x - lastCamX) +
-                    (check.y - lastCamY)*(check.y - lastCamY) +
-                    (check.z - lastCamZ)*(check.z - lastCamZ);
-
-            if (distSq > maxDistSq) {
-                maxDistSq = distSq;
-                indexToRemove = i;
-            }
-        }
-        return indexToRemove;
-    }
 
     /**
      * Ticks all the particles in the engine.
      */
     public void tick() {
-        this.globalTick++;
-
-        Player localPlayer = this.world.players.isEmpty() ? null : this.world.players.get(0);
-        if (localPlayer != null) {
-            this.world.particleEmitters.tick(this.world, localPlayer, GameSettings.PARTICLE_RENDER_DISTANCE.value);
-        }
-
         for (int tt = 0; tt < this.particles.length; tt++) {
             for (int i = 0; i < this.particles[tt].size(); i++) {
                 Particle p = this.particles[tt].get(i);
@@ -127,16 +87,6 @@ public final class ParticleEngine {
                 p.tick();
                 if (p.removed) {
                     this.particles[tt].remove(i--);
-
-                    Class<?> c = p.getClass();
-                    ObjectArrayList<Particle> pl = this.particlePools.get(c);
-                    if (pl == null) {
-                        pl = new ObjectArrayList<>();
-                        this.particlePools.put(c, pl);
-                    }
-                    if (pl.size() < GameSettings.PARTICLES_CAP.value) {
-                        pl.add(p);
-                    }
                 }
             }
         }
@@ -149,6 +99,9 @@ public final class ParticleEngine {
      * @param partialTick The time since the last tick.
      */
     public void renderParticles(@NotNull ICamera camera, float partialTick) {
+//        class Cache {
+//            private static final AABBd cullingAABB = new AABBd();
+//        }
         GLRenderer.pushFrame();
         GLRenderer.setColor4f(1f, 1f, 1f, 1f);
         GLRenderer.setShader(Shaders.PARTICLE);
@@ -169,13 +122,9 @@ public final class ParticleEngine {
         double yOff = camera.getY(partialTick);
         double zOff = camera.getZ(partialTick);
 
-        this.lastCamX = xOff;
-        this.lastCamY = yOff;
-        this.lastCamZ = zOff;
-
         double maxDist = GameSettings.PARTICLE_RENDER_DISTANCE.value * 16.0;
         double maxRenderDistSq = maxDist * maxDist;
-        boolean frustumCull = GameSettings.FRUSTUM_CULLING.value;
+//        boolean frustumCull = GameSettings.FRUSTUM_CULLING.value;
 
         for (int tt = 0; tt == WORLD_TEXTURE; tt++) {
             if (this.particles[tt].isEmpty()) continue;
@@ -186,22 +135,25 @@ public final class ParticleEngine {
             for (int i = 0; i < this.particles[tt].size(); i++) {
                 Particle p = this.particles[tt].get(i);
 
-                double distSq = (p.x - xOff)*(p.x - xOff) + (p.y - yOff)*(p.y - yOff) + (p.z - zOff)*(p.z - zOff);
+                double dx = p.x - xOff;
+                double dy = p.y - yOff;
+                double dz = p.z - zOff;
+                double distSq = dx * dx + dy * dy + dz * dz;
                 if (distSq > maxRenderDistSq) continue;
 
-                if (frustumCull) {
-                    double lerpX = net.minecraft.core.util.helper.MathHelper.lerp(p.xo, p.x, partialTick);
-                    double lerpY = net.minecraft.core.util.helper.MathHelper.lerp(p.yo, p.y, partialTick);
-                    double lerpZ = net.minecraft.core.util.helper.MathHelper.lerp(p.zo, p.z, partialTick);
-                    double r = p.size * 0.1;
-
-                    this.cullingAABB.setMin(lerpX - r, lerpY - r, lerpZ - r);
-                    this.cullingAABB.setMax(lerpX + r, lerpY + r, lerpZ + r);
-
-                    if (!camera.getFrustum().isVisible(this.cullingAABB, partialTick)) {
-                        continue;
-                    }
-                }
+//                if (frustumCull) {
+//                    double lerpX = MathHelper.lerp(p.xo, p.x, partialTick);
+//                    double lerpY = MathHelper.lerp(p.yo, p.y, partialTick);
+//                    double lerpZ = MathHelper.lerp(p.zo, p.z, partialTick);
+//                    double r = p.size * 0.1;
+//
+//                    Cache.cullingAABB.setMin(lerpX - r, lerpY - r, lerpZ - r);
+//                    Cache.cullingAABB.setMax(lerpX + r, lerpY + r, lerpZ + r);
+//
+//                    if (!camera.getFrustum().isVisible(Cache.cullingAABB, partialTick)) {
+//                        continue;
+//                    }
+//                }
 
                 p.render(tessellator, partialTick);
             }
@@ -211,15 +163,6 @@ public final class ParticleEngine {
         GLRenderer.popFrame();
     }
 
-    @SuppressWarnings("unchecked")
-    private <T extends Particle> T getPooledParticle(Class<T> type) {
-        ObjectArrayList<Particle> pool = this.particlePools.computeIfAbsent(type, k -> new ObjectArrayList<>());
-        if (!pool.isEmpty()) {
-            return (T) pool.remove(pool.size() - 1);
-        }
-        return null;
-    }
-
     /**
      * Renders all the particles in the engine whose texture type is ENTITY_PARTICLE_TEXTURE.
      * These particles are drawn using OpenGL normal-based lighting, unlike the other particles,
@@ -228,7 +171,7 @@ public final class ParticleEngine {
      * @param camera      The camera relative to whose perspective the particles should be drawn.
      * @param partialTick The time since the last tick.
      */
-    public void renderLitParticles(ICamera camera, float partialTick) {
+    public void renderLitParticles(@NotNull ICamera camera, float partialTick) {
         int tt = ENTITY_PARTICLE_TEXTURE;
         if (this.particles[tt].isEmpty()) {
             return;
@@ -291,13 +234,7 @@ public final class ParticleEngine {
                     double velY = yp - blockPos.y() - centerY;
                     double velZ = zp - blockPos.z() - centerZ;
 
-                    ParticleBlockBreaking particle = getPooledParticle(ParticleBlockBreaking.class);
-                    if (particle == null) {
-                        particle = new ParticleBlockBreaking(this.world, xp, yp, zp, velX, velY, velZ, block, side, data);
-                    } else {
-                        particle.reset(this.world, xp, yp, zp, velX, velY, velZ, block, side, data);
-                    }
-
+                    ParticleBlockBreaking particle = new ParticleBlockBreaking(this.world, xp, yp, zp, velX, velY, velZ, block, side, data);
                     add(particle.init(blockPos));
                 }
             }
@@ -337,25 +274,11 @@ public final class ParticleEngine {
             xp = blockPos.x() + bounds.maxX() + r;
         }
 
-        ParticleBlockBreaking p = getPooledParticle(ParticleBlockBreaking.class);
-        if (p == null) {
-            p = new ParticleBlockBreaking(this.world, xp, yp, zp, 0.0D, 0.0D, 0.0D, block, side, this.world.getBlockData(blockPos));
-        } else {
-            p.reset(this.world, xp, yp, zp, 0.0D, 0.0D, 0.0D, block, side, this.world.getBlockData(blockPos));
-        }
-
+        ParticleBlockBreaking p = new ParticleBlockBreaking(this.world, xp, yp, zp, 0.0D, 0.0D, 0.0D, block, side, this.world.getBlockData(blockPos));
         add(p.init(blockPos).setPower(0.2F).setScale(0.6F));
     }
 
     public int countParticles() {
         return this.particles[WORLD_TEXTURE].size() + this.particles[ENTITY_PARTICLE_TEXTURE].size();
     }
-
-    public int getGlobalTick() {
-        return globalTick;
-    }
-
-    public void setGlobalTick(int globalTick) {
-        this.globalTick = globalTick;
-    }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/WorldRenderer.java b/game/client/src/main/java/net/minecraft/client/render/WorldRenderer.java
index 7d5b8e246..c299780a8 100644
--- a/game/client/src/main/java/net/minecraft/client/render/WorldRenderer.java
+++ b/game/client/src/main/java/net/minecraft/client/render/WorldRenderer.java
@@ -170,6 +170,10 @@ public class WorldRenderer {
         for (int i = 0; i < entities.size(); i++) {
             final Entity entity = entities.get(i);
 
+            if (entity == this.mc.thePlayer.vehicle && entity.passesThroughRiderTargeting(playerItem)) {
+                continue;
+            }
+
             if (playerItem != null) {
                 if (!playerItem.interactsWithEntity(entity)) continue;
             } else {
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/color/BlockColorConduit.java b/game/client/src/main/java/net/minecraft/client/render/block/color/BlockColorConduit.java
index c6a3a258f..ab3b8efe0 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/color/BlockColorConduit.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/color/BlockColorConduit.java
@@ -43,9 +43,8 @@ public class BlockColorConduit extends BlockColor {
     }
 
     @Override
-    public int getWorldColor(WorldSource world, @NotNull TilePosc tilePos, int tintIndex) {
-        int data = world.getBlockData(tilePos);
-        int strength = data / BlockLogicConduit.STATE_COUNT;
+    public int getWorldColor(@NotNull WorldSource world, @NotNull TilePosc tilePos, int tintIndex) {
+        int strength = BlockLogicConduit.getPower(world, tilePos);
         strength = Math.max(0, Math.min(15, strength));
         return powerColors[strength];
     }
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelConduit.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelConduit.java
index 7c09ff5fc..de26cd26c 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelConduit.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelConduit.java
@@ -17,6 +17,8 @@ public class BlockModelConduit<T extends BlockLogicConduit> extends BlockModelGe
 
     private final ModelState[] stateMapOn = new ModelState[BlockLogicConduit.STATE_COUNT];
     private final ModelState[] stateMapOff = new ModelState[BlockLogicConduit.STATE_COUNT];
+    private final ModelState[] capStateMapOn = new ModelState[6];
+    private final ModelState[] capStateMapOff = new ModelState[6];
     private final ModelState inertState;
 
     public BlockModelConduit(Block<T> block) {
@@ -25,17 +27,31 @@ public class BlockModelConduit<T extends BlockLogicConduit> extends BlockModelGe
         StaticBlockModel onCore = BlockModelDispatcher.loadDataModel("minecraft:block/rubyglass/conduit/conduit_core").asModel();
         StaticBlockModel onStraight = BlockModelDispatcher.loadDataModel("minecraft:block/rubyglass/conduit/conduit_straight").asModel();
         StaticBlockModel onCorner = BlockModelDispatcher.loadDataModel("minecraft:block/rubyglass/conduit/conduit_corner").asModel();
+        StaticBlockModel onCap = BlockModelDispatcher.loadDataModel("minecraft:block/rubyglass/conduit/conduit_cap").asModel();
 
         StaticBlockModel offCore = BlockModelDispatcher.loadDataModel("minecraft:block/rubyglass/conduit/conduit_core_off").asModel();
         StaticBlockModel offStraight = BlockModelDispatcher.loadDataModel("minecraft:block/rubyglass/conduit/conduit_straight_off").asModel();
         StaticBlockModel offCorner = BlockModelDispatcher.loadDataModel("minecraft:block/rubyglass/conduit/conduit_corner_off").asModel();
+        StaticBlockModel offCap = BlockModelDispatcher.loadDataModel("minecraft:block/rubyglass/conduit/conduit_cap_off").asModel();
         this.inertState = new ModelState(onCore, 0, 0, 0);
 
         populateStateMap(stateMapOn, onCore, onStraight, onCorner);
         populateStateMap(stateMapOff, offCore, offStraight, offCorner);
+        populateCapStateMap(capStateMapOn, onCap);
+        populateCapStateMap(capStateMapOff, offCap);
     }
 
-    private void populateStateMap(ModelState[] map, StaticBlockModel core, StaticBlockModel straight, StaticBlockModel corner) {
+    private void populateCapStateMap(ModelState @NotNull [] map, StaticBlockModel cap) {
+        //B
+        map[0] = new ModelState(cap, 0, 0, 0); //DOWN
+        map[1] = new ModelState(cap, 2, 0, 0); //UP
+        map[2] = new ModelState(cap, 1, 0, 0); //N
+        map[3] = new ModelState(cap, 3, 0, 0); //S
+        map[4] = new ModelState(cap, 0, 0, 3); //W
+        map[5] = new ModelState(cap, 0, 0, 1); //E
+    }
+
+    private void populateStateMap(ModelState @NotNull [] map, StaticBlockModel core, StaticBlockModel straight, StaticBlockModel corner) {
         // Core
         map[0] = new ModelState(core, 0, 0, 0); //Closed
 
@@ -63,36 +79,35 @@ public class BlockModelConduit<T extends BlockLogicConduit> extends BlockModelGe
         map[15] = new ModelState(corner, 0, 2, 1); //SE
     }
 
-    @Override
-    public @NotNull StaticBlockModel getModelFromData(int data) {
+    private @NotNull ModelState resolveState(int data) {
         int state = data & BlockLogicConduit.STATE_MASK;
-        int strength = (data >> BlockLogicConduit.POWER_SHIFT) & BlockLogicConduit.POWER_MASK;
 
-        if (state == 0 && strength == 15) {
-            return inertState.model;
+        if (state != 0) {
+            int strength = (data >> BlockLogicConduit.POWER_SHIFT) & BlockLogicConduit.POWER_MASK;
+            return strength == 0 ? stateMapOff[state] : stateMapOn[state];
+        }
+
+        if (BlockLogicConduit.isCap(data)) {
+            int sideId = BlockLogicConduit.getCapSide(data).id;
+            return BlockLogicConduit.isCapPowered(data) ? capStateMapOn[sideId] : capStateMapOff[sideId];
         }
 
-        if (strength == 0) {
-            return stateMapOff[state].model;
-        } else {
-            return stateMapOn[state].model;
+        int strength = (data >> BlockLogicConduit.POWER_SHIFT) & BlockLogicConduit.POWER_MASK;
+        if (strength == BlockLogicConduit.INERT_MARKER) {
+            return inertState;
         }
+        return stateMapOff[0];
+    }
+
+    @Override
+    public @NotNull StaticBlockModel getModelFromData(int data) {
+        return resolveState(data).model;
     }
 
     @Override
     public boolean renderAttached(final @NotNull TessellatorGeneral tessellator, @NotNull final WorldSource worldSource, @NotNull TilePosc tilePos, boolean cullFaces, final @Nullable IconCoordinate overrideTexture) {
         int data = worldSource.getBlockData(tilePos);
-        int state = data & BlockLogicConduit.STATE_MASK;
-        int strength = (data >> BlockLogicConduit.POWER_SHIFT) & BlockLogicConduit.POWER_MASK;
-
-        ModelState activeState;
-        if (state == 0 && strength == 15) {
-            activeState = inertState;
-        } else if (strength == 0) {
-            activeState = stateMapOff[state];
-        } else {
-            activeState = stateMapOn[state];
-        }
+        ModelState activeState = resolveState(data);
 
         return activeState.model.renderAttached(this, tessellator, worldSource, tilePos, activeState.rotX, activeState.rotY, activeState.rotZ, 0, 0, 0, false, cullFaces, overrideTexture);
     }
